use std::{io::{Stdout, Write}, ops::BitOrAssign, time::Duration};

use axum::response::{sse::Event, AppendHeaders};
use clap::builder::NonEmptyStringValueParser;
use lib::{client::Client, message::{Message, MessageKind}, message_read::MessageReader, player::Player};
use crossterm::{
    cursor, event::{self, poll, Event as TermEvent, KeyCode, KeyModifiers}, execute, queue, style, terminal::{
        disable_raw_mode, enable_raw_mode, Clear, ClearType, EnableLineWrap, EnterAlternateScreen
    }
};
use ratatui::{
    buffer::Buffer,
    layout::Rect,
    style::Stylize,
    symbols::border,
    text::{Line, Text},
    widgets::{Block, Paragraph, Widget},
    DefaultTerminal,
    Frame,
};

// async fn delete_player(player: &Player, client: reqwest::Client, addr: &str) -> anyhow::Result<()> {
//     let player_id = &player.name;
//     let response = client
//         .get([&addr, "/delete/", &player_id].concat())
//         .send().await;

//     if let Err(e) = &response {
//         println!("{e}\n");
//         return Ok(())
//     }

//     println!("{}", response?.text().await?);

//     Ok(())
// }

// async fn handle_terminal(player: &Player, stdout: &mut Stdout, client: reqwest::Client, addr: &str) -> anyhow::Result<()> {
//     'handler: loop {
//         while let Ok(_event_happened) = poll(Duration::from_millis(2)) {
//             match event::read().expect("diomerds") {
//                 TermEvent::Key(key) => {
//                     match (key.code, key.modifiers) {
//                         (KeyCode::Char('c'), KeyModifiers::CONTROL) => break 'handler,
//                         (KeyCode::Char('h'), KeyModifiers::NONE) => {
//                             for line in HELP.split('\n') {
//                                 println!("{line}")
//                             }
//                         }, 
//                         (KeyCode::Char('1'), KeyModifiers::NONE) => {
//                             send_player(&player, client.clone(), addr).await?;
//                         },
//                         (KeyCode::Char('2'), KeyModifiers::NONE) => {
//                             delete_player(&player, client.clone(), addr).await?;
//                         },
//                         (_, _) => println!("{:?}\n", key),
//                     }
//                 },
//                 _ => continue,
//             }
//         }
//     }

//     Ok(())
// }

#[tokio::main]
pub async fn main() -> anyhow::Result<()> {
    let mut stdout = std::io::stdout();
    let mut terminal = ratatui::init();
    let app_result = Client::default().run(&mut terminal).await;
    ratatui::restore();
    app_result
}
